﻿package 
{
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.geom.Matrix;
	import flash.display.GradientType;
	
	public class Main extends MovieClip
	{
		public var isDrawing:Boolean;
		
		private const WIDTH:Number = 800;
		private const HEIGHT:Number = 600;
		
		private var background:Sprite;
		private var stars1:Sprite;
		private var stars2:Sprite;
		private var stars3:Sprite;
		private var layers:Array;
		
		private var currentLayer:Number;
		
		private var moveDirection:Number;
		
		public function Main():void
		{
			//draw background...
			var fillType:String = GradientType.LINEAR;
			var colors:Array = [0x034d72, 0x032637];
			var alphas:Array = [1, 1];
			var ratios:Array = [0x00, 0xFF];
			var matr:Matrix = new Matrix();
			//matrix is in radians..
			matr.createGradientBox(800, 600, Math.PI / 2, 0, 0);
			background = new Sprite();
			background.graphics.beginGradientFill(fillType, colors, alphas, ratios, matr);
			background.graphics.drawRect(0, 0, WIDTH, HEIGHT);
			
			layers = new Array();

			this.addChild(background);
			
			stars1 = new Sprite();
			layers.push(stars1);
			stars2 = new Sprite();
			layers.push(stars2);
			stars3 = new Sprite();
			layers.push(stars3);
			this.addChild(stars1);
			this.addChild(stars2);
			this.addChild(stars3);
			
			isDrawing = false;

			
			this.addEventListener(MouseEvent.MOUSE_DOWN, startDraw);
			this.addEventListener(MouseEvent.MOUSE_UP, stopDraw);
			this.addEventListener(Event.ENTER_FRAME, onDraw);
			
			moveDirection = 1;
			
			currentLayer = 0;
		}
		
		private function onDraw(e:Event):void 
		{
			if (isDrawing)
			{
				drawStar(this.mouseX,this.mouseY,0xFFFFFF * Math.random(), 5, Math.random() * 25, Math.random() * 25 + 25, Math.random() * 180);
			}
			
			var stars:Sprite = Sprite(layers[0]);
			stars.y += moveDirection;
			
			for (var i:Number = 0; i < layers.length; i++)
			{
				layers[i].y += moveDirection * (i+1);
				
			}
			
			if (stars.y >= 100)
			{
				stars.y = 100;
				moveDirection = -1;
			}
			if (stars.y <= 0)
			{
				stars.y = 0;
				moveDirection = 1;
			}
		}
		
		private function stopDraw(e:MouseEvent):void 
		{
			isDrawing = false;
		}
		
		private function startDraw(e:MouseEvent):void 
		{
			isDrawing = true;
			currentLayer++;
			if (currentLayer >= layers.length)
			{
				currentLayer = 0; 
			}
		}
		
		public function drawStar(x:Number,y:Number,colour:Number = 0xFFFF00,numTips:int = 5, innerRadius:Number = 25, outerRadius:Number = 50,angle:Number = 0 ):void
		{
			var stars:Sprite = Sprite(layers[currentLayer]);
			trace(currentLayer);
			stars.graphics.lineStyle(1, colour, 1);
		
			if (numTips > 2)
			{
				var centerX:Number = outerRadius;
				var centerY:Number = outerRadius;
				var step:Number, halfStep:Number, startAngle:Number, dx:Number, dy:Number;
				
				step = (Math.PI * 2) / numTips;
				halfStep = step / 2;
				
				//convert angle to radians
				startAngle = (angle / 180) * Math.PI
				
				dx = centerX + (Math.cos(startAngle) * outerRadius)+x;
				dy = centerY - (Math.sin(startAngle) * outerRadius)+y;
				
				stars.graphics.moveTo(dx, dy);
				
				for (var i:int = 1; i <= numTips; i++)
				{
					dx = centerX + Math.cos(startAngle + (step * i) - halfStep) * innerRadius+x;
					dy = centerY - Math.sin(startAngle + (step * i) - halfStep) * innerRadius+y;
					

					stars.graphics.lineTo(dx, dy);
					
					dx = centerX + Math.cos(startAngle + (step * i)) * outerRadius+x;
					dy = centerY - Math.sin(startAngle + (step * i)) * outerRadius+y;

					stars.graphics.lineTo(dx, dy);
				}
					
			}			
		}
	}
}